//---------------------------------------------------------------------------

#ifndef UMainH
#define UMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <StdActns.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include "DisAsmView.h"
#include <ExtCtrls.hpp>
#include "CodeBPList.h"
#include "Debugger.h"
#include "ExportsList.h"
#include "ExecBreakpoint.h"
#include "DataBPList.h"
#include "DumpView.h"
#include "StackView.h"
#include <Grids.hpp>
//---------------------------------------------------------------------------
class TFMain : public TForm
{
__published:	// IDE-managed Components
      TActionList *ActionList1;
      TAction *aDebugRun;
      TAction *aDebugPause;
      TAction *aDebugStepOver;
      TAction *aDebugStepInto;
      TAction *aDebugStop;
      TStatusBar *StatusBar1;
      TPanel *Panel1;
      TDebugger *Debugger;
      TExportsList *ExportsList;
      TCodeBPList *CodeBPList;
      TDataBPList *DataBPList1;
      TStackView *StackView;
      TSplitter *Splitter1;
      TSplitter *Splitter2;
      TPanel *Panel3;
      TDumpView *DumpView;
      TSplitter *Splitter3;
      TDisAsmView *DisAsmView;
      TPanel *Panel2;
      TLabel *Label1;
      TLabel *Label2;
      TLabel *Label3;
      TLabel *Label4;
      TLabel *Label5;
      TLabel *Label6;
      TLabel *Label7;
      TLabel *Label8;
      TLabel *Label9;
      TLabel *Label10;
      TEdit *edEAX;
      TEdit *edEBX;
      TEdit *edECX;
      TEdit *edEDX;
      TEdit *edESI;
      TEdit *edEDI;
      TEdit *edESP;
      TEdit *edEBP;
      TEdit *edEFLAGS;
      TEdit *edEIP;
      TImageList *imglDebug;
      TImageList *imglGutterGlyphs;
      TMainMenu *MainMenu1;
      TMenuItem *File1;
      TMenuItem *Open1;
      TMenuItem *Exit1;
      TMenuItem *Debug1;
      TMenuItem *Run1;
      TMenuItem *ProgramPause1;
      TMenuItem *StepInto1;
      TMenuItem *StepOver1;
      TMenuItem *Stop1;
      TMenuItem *N1;
      TMenuItem *About1;
      TToolBar *ToolBar1;
      TToolButton *ToolButton1;
      TToolButton *ToolButton2;
      TToolButton *ToolButton3;
      TToolButton *ToolButton4;
      TToolButton *ToolButton5;
      TFileExit *FileExit;
      TFileOpen *FileOpen;
      void __fastcall FileOpenAccept(TObject *Sender);
      void __fastcall aDebugRunUpdate(TObject *Sender);
      void __fastcall aDebugPauseUpdate(TObject *Sender);
      void __fastcall aDebugStepOverUpdate(TObject *Sender);
      void __fastcall aDebugStepIntoUpdate(TObject *Sender);
      void __fastcall aDebugStopUpdate(TObject *Sender);
      void __fastcall aDebugRunExecute(TObject *Sender);
      void __fastcall aDebugPauseExecute(TObject *Sender);
      void __fastcall aDebugStepOverExecute(TObject *Sender);
      void __fastcall aDebugStepIntoExecute(TObject *Sender);
      void __fastcall aDebugStopExecute(TObject *Sender);
      void __fastcall DebuggerChangeDebuggerState(TObject *Sender,
          DWORD dwThreadId, TDebuggerState NewState);
      void __fastcall DebuggerCreateProcessDbgEvent(TObject *Sender,
          DWORD dwThreadId, CREATE_PROCESS_DEBUG_INFO CreateProcessInfo);
      void __fastcall DebuggerExitProcessDbgEvent(TObject *Sender,
          DWORD dwThreadId, EXIT_PROCESS_DEBUG_INFO ExitProcess);
      void __fastcall DebuggerCodeBPDetected(TObject *Sender,
          DWORD dwThreadId, TCodeBP *CodeBP);
      void __fastcall DebuggerCreateThreadDbgEvent(TObject *Sender,
          DWORD dwThreadId, CREATE_THREAD_DEBUG_INFO CreateThread,
          bool Pause);
      void __fastcall DebuggerDataBPDetected(TObject *Sender,
          DWORD dwThreadId, TDataBP *DataBP);
      void __fastcall DebuggerDebugStringDbgEvent(TObject *Sender,
          DWORD dwThreadId, AnsiString DebugString,
          OUTPUT_DEBUG_STRING_INFO DebugStringInfo, bool Pause);
      void __fastcall DebuggerExceptionDbgEvent(TObject *Sender,
          DWORD dwThreadId, EXCEPTION_DEBUG_INFO Exception);
      void __fastcall DebuggerExitThreadDbgEvent(TObject *Sender,
          DWORD dwThreadId, EXIT_THREAD_DEBUG_INFO ExitThread, bool Pause);
      void __fastcall DebuggerInvalidBPCondition(TObject *Sender,
          AnsiString BPCondition);
      void __fastcall DebuggerLoadDllDbgEvent(TObject *Sender,
          DWORD dwThreadId, LOAD_DLL_DEBUG_INFO LoadDll, bool Pause);
      void __fastcall DebuggerNeedStateShow(TObject *Sender,
          DWORD dwThreadId, bool OnlyContext);
      void __fastcall DebuggerRipDbgEvent(TObject *Sender,
          DWORD dwThreadId, RIP_INFO RipInfo, AnsiString SystemMessage);
      void __fastcall DebuggerThreadsListChange(TObject *Sender);
      void __fastcall DebuggerUnhandledException(TObject *Sender,
          EXCEPTION_RECORD ExceptionRecord, bool &bTerminateProcess);
      void __fastcall DebuggerUnknownDebugEvent(TObject *Sender,
          DWORD dwThreadId);
      void __fastcall DebuggerUnloadDllDbgEvent(TObject *Sender,
          DWORD dwThreadId, UNLOAD_DLL_DEBUG_INFO UnloadDll, bool Pause);
      void __fastcall DisAsmViewGutterClick(TObject *Sender, int X, int Y,
          int Line);
      void __fastcall CodeBPListChange(TObject *Sender,
          TExecBreakpointsListChangeType ChangeType,
          TExecBreakpointsListChangeInfo ChangeInfo);
      void __fastcall About1Click(TObject *Sender);
      void __fastcall DebuggerChangeCurrentInstr(TObject *Sender,
          TAsmCode AsmCode, DWORD EIP);
      void __fastcall DebuggerInternalError(TObject *Sender,
          AnsiString File, int Line, AnsiString Message);
private:	// User declarations
      void ShowCPUState(DWORD dwThreadId);
public:		// User declarations
      __fastcall TFMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TFMain *FMain;
//---------------------------------------------------------------------------
#endif
