/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
*      Debugger Engine                                                       *
*      File: CodeBPList.h                                                    *
*      Copyright (c) 2004-2005 Fysyuk Victor, <RockDbgSupport@ua.fm>         *
*      ALL RIGHTS RESERVED.                                                  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#ifndef CodeBPListH
#define CodeBPListH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>
#include "ExecBreakpoint.h"
//---------------------------------------------------------------------------

enum TCodeBPKind
{
        CBP_NORMAL,
        CBP_FUNCTION, //Function Breakpoint
        CBP_STEPOVER,
        CBP_INTERNAL
};

class TCodeBPList;

class PACKAGE TCodeBP : public TExecBreakpoint
{
friend TCodeBPList;
private:
      DWORD FProcessID;
      DWORD FAddress;
      AnsiString FFunction;
      BYTE FOriginalByte;
      TCodeBPKind FBPType;
protected:
      virtual void __fastcall SetEnabled(bool value);
public:
      __fastcall TCodeBP(DWORD ProcessID, DWORD Address, TCodeBPKind Type);
      __fastcall ~TCodeBP();
      __property DWORD ProcessID = { read=FProcessID };
      __property DWORD Address = { read=FAddress };
      __property AnsiString Function = { read=FFunction };
      __property BYTE OriginalByte  = { read=FOriginalByte };
      __property TCodeBPKind BPType  = { read=FBPType };
};

class PACKAGE TCodeBPList : public TExecBreakpointsList
{
private:
      DWORD FProcessID;
      TCodeBP* __fastcall GetBreakpoints(int Index);
public:
      __fastcall TCodeBPList(TComponent* Owner);
      __fastcall ~TCodeBPList();
      TCodeBP *Add(DWORD Address,TCodeBPKind Type = CBP_NORMAL);
      TCodeBP *Add(DWORD Address,AnsiString FuncName);
      __property TCodeBP *Breakpoints[int Index] = { read=GetBreakpoints };
      __property DWORD ProcessID  = { read=FProcessID, write=FProcessID };
      TCodeBP* Find(DWORD Address, int *Index = NULL);
      void __fastcall Delete(DWORD Address);
      void __fastcall Clear();
__published:
      __property OnChange;
};
//---------------------------------------------------------------------------
#endif

