/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
*      Debugger Engine                                                       *
*      File: DebuggerErrors.h                                                *
*      Copyright (c) 2004-2005 Fysyuk Victor, <RockDbgSupport@ua.fm>         *
*      ALL RIGHTS RESERVED.                                                  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#ifndef DebuggerErrorsH
#define DebuggerErrorsH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>

class EDebuggerInternalError : public Exception
{
private:
      AnsiString FFile;
      int FLine;
public:
      EDebuggerInternalError(AnsiString File, int Line);
      EDebuggerInternalError(AnsiString Message, AnsiString File, int Line);
      __property AnsiString File  = { read=FFile };
      __property int Line  = { read=FLine };
};

#ifdef NO_DEBUGCRASH_ASSERTION
#define ASSERT(p)       ((void)0)
#define ASSERTM(p, m)    ((void)0)
#else
#define ASSERT(p)       ((p) ? (void)0 : throw EDebuggerInternalError(__FILE__, __LINE__))
#define ASSERTM(p,m)     ((p) ? (void)0 : throw EDebuggerInternalError(m, __FILE__, __LINE__))
#endif

#endif
