/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
*      Debugger Engine                                                       *
*      File: ExprParser.h                                                    *
*      Copyright (c) 2004-2005 Fysyuk Victor, <RockDbgSupport@ua.fm>         *
*      ALL RIGHTS RESERVED.                                                  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#ifndef ExprParserH
#define ExprParserH

#include <system.hpp>
#include <SysUtils.hpp>
#include "Debugger.h"
//---------------------------------------------------------------------------

#pragma option push -b-
enum TExprTokenType
{
	TOK_NUMBER,
      TOK_CHAR,
      TOK_REGISTER,

      TOK_LEFT_PAR,
      TOK_RIGHT_PAR,
      TOK_PLUS,
      TOK_MINUS,
      TOK_ASTERISK,
      TOK_SLASH,
      TOK_PERCENT,

      TOK_BYTE,
      TOK_WORD,
      TOK_DWORD,
      TOK_LEFT_SQUARE_PAR,
      TOK_RIGHT_SQUARE_PAR,

      TOK_BITWISE_COMPLEMENT,
      TOK_BITWISE_AND,
      TOK_BITWISE_XOR,
      TOK_BITWISE_OR,
      TOK_BITWISE_SHIFT_RIGHT,
      TOK_BITWISE_SHIFT_LEFT,

      TOK_LOGICAL_NOT,
      TOK_LOGICAL_AND,
      TOK_LOGICAL_OR,
      TOK_LOGICAL_EQUAL,
      TOK_LOGICAL_NOT_EQUAL,
      TOK_LOGICAL_GREAT,
      TOK_LOGICAL_LESS,
      TOK_LOGICAL_NOT_GREAT,
      TOK_LOGICAL_NOT_LESS,

      TOK_END,
      TOK_INVALID
};
#pragma option pop

class PACKAGE TExprParser
{
private:
      AnsiString FString;
	AnsiString FTokenString;
      TExprTokenType FTokenType;
      char FTokenChar;
      DWORD FTokenValue;
      int FIndex;
      DWORD FThreadId;
	TDebugger *FDebugger;
	void get_token();
	void inline __fastcall get_next_char();
	DWORD __fastcall expr();
	DWORD __fastcall term();
	DWORD __fastcall fact();
	DWORD __fastcall memory();
	bool __fastcall logical_expr();
	bool __fastcall logical_term();
	bool __fastcall logical_fact();
public:
	TExprParser(TDebugger *ADebugger, DWORD dwThreadId);
	bool Evaluate(AnsiString S, DWORD &Value);
      bool EvaluateLogical(AnsiString S, bool &Value);
	__property TDebugger *Debugger  = { read=FDebugger, write=FDebugger };
      __property DWORD ThreadId  = { read=FThreadId, write=FThreadId };
};

#endif
