/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
*      Debugger Engine                                                       *
*      File: Modules.h                                                       *
*      Copyright (c) 2004-2005 Fysyuk Victor, <RockDbgSupport@ua.fm>         *
*      ALL RIGHTS RESERVED.                                                  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#ifndef ModulesH
#define ModulesH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Psapi.h>

#define PSAPI_LIBRARY         "psapi.dll"
#define MAX_MODULES_COUNT     0x100

typedef
BOOL
WINAPI
(*TEnumProcessModules)(
    HANDLE hProcess,
    HMODULE *lphModule,
    DWORD cb,
    LPDWORD lpcbNeeded
    );

typedef
BOOL
WINAPI
(*TGetModuleInformation)(
    HANDLE hProcess,
    HMODULE hModule,
    LPMODULEINFO lpmodinfo,
    DWORD cb
    );

typedef
DWORD
WINAPI
(*TGetModuleFileNameExA)(
    HANDLE hProcess,
    HMODULE hModule,
    LPSTR lpFilename,
    DWORD nSize
    );

typedef
DWORD
WINAPI
(*TGetModuleFileNameExW)(
    HANDLE hProcess,
    HMODULE hModule,
    LPWSTR lpFilename,
    DWORD nSize
    );

#ifdef UNICODE
#define TGetModuleFileNameEx  TGetModuleFileNameExW
#else
#define TGetModuleFileNameEx  TGetModuleFileNameExA
#endif // !UNICODE

typedef
DWORD
WINAPI
(*TGetModuleBaseNameA)(
    HANDLE hProcess,
    HMODULE hModule,
    LPSTR lpBaseName,
    DWORD nSize
    );

typedef
DWORD
WINAPI
(*TGetModuleBaseNameW)(
    HANDLE hProcess,
    HMODULE hModule,
    LPWSTR lpBaseName,
    DWORD nSize
    );

#ifdef UNICODE
#define TGetModuleBaseName  TGetModuleBaseNameW
#else
#define TGetModuleBaseName  TGetModuleBaseNameA
#endif // !UNICODE

struct TModule
{
      AnsiString Path;
      AnsiString BaseName;
      MODULEINFO ModuleInfo;
};

class PACKAGE TModulesList
{
private:
      HMODULE hPsapiDll;
      TEnumProcessModules FEnumProcessModules;
      TGetModuleInformation FGetModuleInformation;
      TGetModuleFileNameEx FGetModuleFileNameEx;
      TGetModuleBaseName FGetModuleBaseName;

      TModule *FModules;
      HANDLE FProcess;
      DWORD FCount;
      DWORD FMaxCount;
      TModule __fastcall GetItems(DWORD Index);
public:
      __fastcall TModulesList(HANDLE hProcess, DWORD dwMaxCount);
      __fastcall ~TModulesList();
      BOOL __fastcall EnumModules();
      TModule* __fastcall FindModule(LPVOID lpBaseOfDll) const;
      TModule* __fastcall GetModuleByAddress(DWORD Address);
      __property TModule Items[DWORD Index] = { read=GetItems };
      __property HANDLE Process  = { read=FProcess };
      __property DWORD Count  = { read=FCount };
      __property DWORD MaxCount  = { read=FMaxCount };
};
#endif
