/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
*      Debugger Engine                                                       *
*      File: StackView.h                                                     *
*      Copyright (c) 2004-2005 Fysyuk Victor, <RockDbgSupport@ua.fm>         *
*      ALL RIGHTS RESERVED.                                                  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#ifndef StackViewH
#define StackViewH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>
#include "DumpView.h"
#include <Controls.hpp>
#include <Grids.hpp>
//---------------------------------------------------------------------------
class PACKAGE TCustomStackView : public TCustomDumpView
{
private:
      Graphics::TIcon* FStackTopIcon;
      void __fastcall SetStackTopIcon(Graphics::TIcon* value);
      bool __fastcall IsStackTopIconStored();
      DWORD __fastcall GetStackTop();
protected:
      virtual void __fastcall DrawCell(int ACol, int ARow, const Types::TRect & ARect, TGridDrawState AState);
public:
      __fastcall TCustomStackView(TComponent* Owner);
      __fastcall ~TCustomStackView();
      __property DWORD StackTop  = { read=GetStackTop };
      __property Graphics::TIcon* StackTopIcon  = { read=FStackTopIcon, write=SetStackTopIcon, stored=IsStackTopIconStored };
      void __fastcall ShowStackMemory() { ShowMemory( StackTop ); };
};

class TStackView : public TCustomStackView
{
__published:
      /* inherited properties */
      __property Align;
      __property Anchors;
      __property Constraints;
      __property Color = {default = clBtnFace};
      __property Ctl3D;
      __property Cursor;
      __property ParentCtl3D;
      __property Enabled;
      __property Font;
      __property Height;
      __property HelpContext;
      __property HelpKeyword;
      __property HelpType;
      __property Hint;
      __property Left;
      __property Name;
      __property ParentColor;
      __property ParentFont;
      __property ParentShowHint;
      __property PopupMenu;
      __property ShowHint;
      __property TabOrder;
      __property TabStop = { default=true };
      __property Tag;
      __property Top;
      __property Visible;
      __property Width;
      /* inherited events */
      __property OnClick;
      __property OnDblClick;
      __property OnDragDrop;
      __property OnDragOver;
      __property OnEndDock;
      __property OnStartDock;
      __property OnEndDrag;
      __property OnEnter;
      __property OnExit;
      __property OnKeyDown;
      __property OnKeyPress;
      __property OnKeyUp;
      __property OnMouseDown;
      __property OnMouseMove;
      __property OnMouseUp;
      __property OnSelectCell;
      __property OnStartDrag;
      /* inherited from TCustomDumpView properties */
      __property Debugger;
	__property ScrollBars;
      __property DisplayFormat;
      /* TCustomStackView properties */
      __property StackTopIcon;
public:
      #pragma option push -w-inl
	inline __fastcall virtual TStackView(Classes::TComponent* AOwner) : TCustomStackView(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	inline __fastcall virtual ~TStackView(void) { }
	#pragma option pop
};
//---------------------------------------------------------------------------
#endif
